服务端 API/消息/消息管理/回复消息
# 回复消息

回复指定消息，支持文本、富文本、卡片、群名片、个人名片、图片、视频、文件等多种消息类型。

**注意事项**：注意事项:
- 需要开启[机器人能力](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-enable-bot-ability)  
- 回复私聊消息，需要机器人对用户有[可用性](https://open.larksuite.com/document/home/introduction-to-scope-and-authorization/availability)
- 回复群组消息，需要机器人在群中
- 为避免对用户造成打扰，向同一用户发送消息的限频为 ==5 QPS==，向同一群组发送消息的限频为群内机器人共享 ==5 QPS==

## 请求

基本 | &nbsp;
---|---
HTTP URL | https://open.larksuite.com/open-apis/im/v1/messages/:message_id/reply
HTTP Method | POST
接口频率限制 | [1000 次/分钟、50 次/秒](https://open.larksuite.com/document/ukTMukTMukTM/uUzN04SN3QjL1cDN)
支持的应用类型 | Custom App、Store App
权限要求<br>**调用该 API 所需的权限。开启其中任意一项权限即可调用**<br>开启任一权限即可 | 获取与发送单聊、群组消息(im:message)<br>以应用的身份发消息(im:message:send_as_bot)<br>发送消息V2(im:message:send)

### 请求头

名称 | 类型 | 必填 | 描述
---|---|---|---
Authorization | string | 是 | `tenant_access_token`<br>**值格式**："Bearer `access_token`"<br>**示例值**："Bearer t-7f1bcd13fc57d46bac21793a18e560"<br>[了解更多：如何选择与获取 access token](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-choose-which-type-of-token-to-use)
Content-Type | string | 是 | **固定值**："application/json; charset=utf-8"

### 路径参数

名称 | 类型 | 描述
---|---|---
message_id | string | 待回复的消息的ID，详情参见[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)<br>**示例值**："om_dc13264520392913993dd051dba21dcf"

### 请求体

名称 | 类型 | 必填 | 描述
---|---|---|---
content | string | 是 | 消息内容 json 格式，格式说明参考: [发送消息内容](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/im-v1/message/create_json)<br>**示例值**："`{\"text\":\"test content\"}`"
msg_type | string | 是 | 消息类型，包括：text、post、image、file、audio、media、sticker、interactive、share_card、share_user<br>**示例值**："text"
reply_in_thread | boolean | 否 | 是否以话题形式回复；若要回复的消息已经是话题消息，则默认以话题形式进行回复<br>**示例值**：false<br>**默认值**：`false`
uuid | string | 否 | 由开发者生成的唯一字符串序列，用于回复消息请求去重；持有相同uuid的请求1小时内至多成功执行一次<br>**示例值**："选填，每次调用前请更换，如a0d69e20-1dd1-458b-k525-dfeca4015204"<br>**数据校验规则**：<br>- 最大长度：`50` 字符

### 请求体示例
```json
{
    "content": "{\"text\":\"test content\"}",
    "msg_type": "text",
    "reply_in_thread": true,
    "uuid": "选填，若填写每次调用前请更换，如：a0d69e20-1dd1-458b-k525-dfeca4015204"
}
```

**请求示例**

```json 
curl --location --request POST 'https://open.larksuite.com/open-apis/im/v1/messages/om_xxxxxx/reply' \
--header 'Authorization: Bearer t-xxxxxx' \
--header 'Content-Type: application/json; charset=utf-8' \
--data-raw '{
    "content": "{\"text\":\"test content\"}",
    "msg_type": "text",
    "uuid": "a0d69e20-1dd1-458b-k525-dfeca4015204"
}'
```

## 响应

### 响应体

名称 | 类型 | 描述
---|---|---
code | int | 错误码，非 0 表示失败
msg | string | 错误描述
data | message | \-
message_id | string | 消息id，说明参见：[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)
root_id | string | 根消息id，用于回复消息场景，说明参见：[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)
parent_id | string | 父消息的id，用于回复消息场景，说明参见：[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)
thread_id | string | 消息所属的话题 ID（不返回说明该消息非话题消息），说明参见：[话题介绍](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/thread-introduction)
msg_type | string | 消息类型 包括：text、post、image、file、audio、media、sticker、interactive、share_chat、share_user等，类型定义请参考[接收消息内容](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/im-v1/message/events/message_content)
create_time | string | 消息生成的时间戳（毫秒）
update_time | string | 消息更新的时间戳（毫秒）
deleted | boolean | 消息是否被撤回
updated | boolean | 消息是否被更新
chat_id | string | 所属的群
sender | sender | 发送者，可以是用户或应用
id | string | 该字段标识发送者的id
id_type | string | 该字段标识发送者的id类型<br>**可选值有：**<br>- `open_id`<br>- `app_id`
sender_type | string | 该字段标识发送者的类型<br>**可选值有：**<br>- `user`: 用户<br>- `app`: 应用<br>- `anonymous`: 匿名<br>- `unknown`: 未知
tenant_key | string | 为租户在Lark上的唯一标识，用来换取对应的tenant_access_token，也可以用作租户在应用里面的唯一标识
body | message_body | 消息内容
content | string | 消息内容，json结构序列化后的字符串。不同msg_type对应不同内容。消息类型 包括：text、post、image、file、audio、media、sticker、interactive、share_chat、share_user等，类型定义请参考：[接收消息内容](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/im-v1/message/events/message_content)
mentions | mention\[\] | 被@的用户或机器人的id列表
key | string | 被@的用户或机器人的序号。例如，第3个被@到的成员，值为“@_user_3”
id | string | 被@的用户或者机器人的open_id
id_type | string | 被@的用户或机器人 id 类型，目前仅支持 `open_id` ([什么是 Open ID？](https://open.larksuite.com/document/home/user-identity-introduction/open-id))
name | string | 被@的用户或机器人的姓名
tenant_key | string | 为租户在Lark上的唯一标识，用来换取对应的tenant_access_token，也可以用作租户在应用里面的唯一标识
upper_message_id | string | 合并转发消息中，上一层级的消息id message_id，说明参见：[消息ID说明](https://open.larksuite.com/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/message/intro#ac79c1c2)

### 响应体示例
```json
{
    "code": 0,
    "msg": "success",
    "data": {
        "message_id": "om_dc13264520392913993dd051dba21dcf",
        "root_id": "om_40eb06e7b84dc71c03e009ad3c754195",
        "parent_id": "om_d4be107c616aed9c1da8ed8068570a9f",
        "thread_id": "omt_d4be107c616a",
        "msg_type": "card",
        "create_time": "1615380573411",
        "update_time": "1615380573411",
        "deleted": false,
        "updated": false,
        "chat_id": "oc_5ad11d72b830411d72b836c20",
        "sender": {
            "id": "cli_9f427eec54ae901b",
            "id_type": "app_id",
            "sender_type": "app",
            "tenant_key": "736588c9260f175e"
        },
        "body": {
            "content": "{\"text\":\"@_user_1 test content\"}"
        },
        "mentions": [
            {
                "key": "@_user_1",
                "id": "ou_155184d1e73cbfb8973e5a9e698e74f2",
                "id_type": "open_id",
                "name": "Tom",
                "tenant_key": "736588c9260f175e"
            }
        ],
        "upper_message_id": "om_40eb06e7b84dc71c03e009ad3c754195"
    }
}
```

### 错误码

HTTP状态码 | 错误码 | 描述 | 排查建议
---|---|---|---
400 | 230001 | Your request contains an invalid request parameter. | 参数错误，请根据接口返回的错误信息并参考文档检查输入参数。
400 | 230002 | The bot can not be outside the group. | 机器人不在对应群组中。
400 | 230006 | Bot ability is not activated. | [机器人能力](https://open.larksuite.com/document/uAjLw4CM/ugTN1YjL4UTN24CO1UjN/trouble-shooting/how-to-enable-bot-ability)未启用 。可在[开发者后台](https://open.larksuite.com/app) -> 应用能力 -> 添加应用能力页面添加机器人功能，发布新版本后生效。
400 | 230011 | The message is recalled. | 消息已被撤回，不支持该操作。
400 | 230013 | Bot has NO availability to this user. | 机器人对用户没有[可用性](https://open.larksuite.com/document/home/introduction-to-scope-and-authorization/availability)。可在[开发者后台](https://open.larksuite.com/app) -> 应用发布 -> 版本管理与发布 -> 创建版本页面编辑应用的可用范围，发布新版本后生效。
400 | 230015 | P2P chat can NOT be shared. | 私聊会话不允许被分享。
400 | 230017 | Bot is NOT the owner of the resource. | 机器人不是资源的拥有者。
400 | 230018 | These operations are NOT allowed at current group settings. | 当前操作被群设置禁止，请检查群设置或联系群管理员。
400 | 230019 | The topic does NOT exist. | 当前话题不存在。
400 | 230020 | This operation triggers the frequency limit. | 当前操作触发限频，请降低请求频率。
400 | 230022 | The content of the message contains sensitive information. | 消息包含敏感信息，请检查消息内容。
400 | 230025 | The length of the message content reaches its limit. | 消息体长度超出限制。文本消息最大不能超过150KB，卡片及富文本消息最大不能超过30KB；此外，若消息中包含大量样式标签，会使实际消息体长度大于您输入的请求体长度。
400 | 230027 | Lack of necessary permissions. | 无权进行本操作，可能的原因有：<br>1. 缺少相应权限，请根据错误信息进行排查；<br>2. 未检查到用户授权信息；<br>3. 暂不支持在外部群中进行本操作。
400 | 230028 | The messages do NOT pass the audit. | 消息DLP审查未通过，当消息内容中含有明文电话号码、明文个人邮箱等内容时可能会触发该错误；请根据接口返回的错误信息检查消息内容。
400 | 230035 | Send Message Permission deny. | 没有发送消息的权限，请排查群是否已开启禁言、被对方屏蔽或受到租户维度沟通权限的管控。
400 | 230038 | Cross tenant p2p chat operate forbid. | 跨租户的单聊不允许通过本接口发送消息。
400 | 230049 | The message is being sent. | 消息正在发送中，请稍后。
400 | 230050 | The message is invisible to the operator. | 该消息对于操作者不可见，无法进行本操作。
400 | 230054 | This operation is not supported for this message type. | 该消息类型不支持本操作。
400 | 230055 | The type of file upload does not match the type of message being sent. | 文件上传时选择的类型与发送的消息类型不匹配。
400 | 230071 | The group to which the message belongs does not support reply in thread. | 该消息所属的群聊不支持以话题形式回复。
400 | 230072 | Aggregated messages do not support reply in thread. | 已聚合的消息不支持以话题形式回复。
400 | 230075 | Sending encrypted messages is not supported. | 暂不支持发送加密消息。
400 | 230099 | Failed to create card content. | 创建卡片消息内容失败，请根据错误信息排查卡片 JSON 内容。
400 | 230111 | Action unavailable as the message will self-destruct soon. | 不能回复定时删除的消息。
400 | 232009 | Your request specifies a chat which has already been dissolved. | 群组已被解散。

其他服务端错误码参考：[服务端错误码说明](https://open.larksuite.com/document/ukTMukTMukTM/ugjM14COyUjL4ITN)

